/***************************************************************************
 *   Copyright (C) 2009 by Stefan Bühler                                   *
 *   stbuehler@web.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TORUSCHESSTESTGAME_H
#define TORUSCHESSTESTGAME_H

#include <QWidget>
#include <QSvgRenderer>
#include <QMainWindow>
#include <QSize>

#include "toruschess.h"
#include "piecelibrary.h"

#include "optiondlg.h"

/**
	@author Stefan Bühler <stbuehler@web.de>
*/
namespace toruschess {
	
	class TestGame : public QMainWindow {
	Q_OBJECT
	public:
		TestGame(QWidget *parent = 0);
	
	private slots:
		void gameUpdated();
		void gameChanged(GameState state);
		
		void menuRestart();
		void menuOptions();
	
	private:
		Game *m_game;
		OptionDlg *m_optionDlg;
	};
}

#endif
